/******************************************
 *  Seg 2501, hiver 2002 Devoir # 4
 *
 *  fichier Caissiere.java
 *  Simule un nombre de caissires et leur
 *  comportement au service des clients.
 *
 *  @author  Anne Bertrand
 *  @author  Robin Tropper
 *  @refactoredBy Robin Tropper  B.Sc.A.
 *
 ******************************************/

import java.util.*;

class Caissiere {
	private String nom;
	private Timer ceduleProchain;
	private long tempsDePaperasse;
	
	public Caissiere(int num) {
		ceduleProchain = new Timer();
		nom="Caisse_"+num;
		//estimons de 2  4 minutes pour la
		//paperasse entre clients
		tempsDePaperasse = GenerateurR.generer(30, 10);
		System.out.println("DEMARRE "+nom);
		prochainClient();
	}//fin constructeur

	class ServirProchain extends TimerTask {
		Caissiere caisse = null;		
		public void run() {
			prochainClient();
		}//fin du run
	}//fin de classe interne
	
	private void prochainClient(){
		Client clientAServir = null;
		List<FileClient> filesEnBanque = Banque.montreFiles();
		long tempsService = -1;
		while( clientAServir == null ){
			
			//OPTIONNEL :
			//le temps de prparer la paperasse!
			try {
				Thread.sleep( tempsDePaperasse );
			} catch (InterruptedException e1) {
				e1.printStackTrace();
			}
			
			//trouver le prochain client  servir
			for(int  i=0; i<filesEnBanque.size(); i++){
				try {
					clientAServir = filesEnBanque.get(i).Servir();
					tempsService = clientAServir.getTempsAServir();
					System.out.println("------ caissire "+nom+" : sert client "+clientAServir.getNom()+" ------");
					//client trouv en priorit, ne cherchez pas plus loin
					break;
				} catch (Exception e) {
					//file vide : aucun client  servir - passe au prochain
					System.out.println("------ caissire "+nom+" : pas de clients prts en ce moment ------");
					//la banque ferme = arrte!
					if( Banque.estFerme() ){
						return;
					}
					//en attendant, fais de la paperasse
					try {
						Thread.sleep(tempsDePaperasse*5);
					} catch (InterruptedException e1) {
						e1.printStackTrace();
					}//5: arbitraire!
					//e.printStackTrace();
				}
			}//fin parcours des files
		}//fin while pas de client  servir
		
		ceduleProchain.schedule(new ServirProchain(), tempsService );
	}//fin prochain client

}//fin de classe Caissire